<template>
  <div class="sidebar">
    <div class="page-sidebar__top">
      <template v-if="menu">
        <Collapse v-model="activeNames" accordion>
          <CollapseItem
            v-for="(item, index) in menu"
            :key="index"
            :title="item.page.pages_contents[0].name_in_menu"
            :name="item.page.slug"
          >
            <ul>
              <li
                v-for="(block, blockIndex) in item.page.pages_contents[0]
                  .pages_contents_blocks"
                :key="blockIndex"
              >
                <nuxt-link :to="localePath(`${item.page.slug}#${block.hash}`)">
                  {{ block.menu_label }}
                </nuxt-link>
              </li>
            </ul>
          </CollapseItem>
        </Collapse>
      </template>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, useAsync, ref } from '@nuxtjs/composition-api'
import useGetLocales from '@/hooks/get-locales'
import { AppEvents } from '~/types'
import { useGetMenuPagesQuery } from '~/sdk/hooks'
import { MenuPageFragment } from '@/sdk/types'

import Collapse from '@/components/element/Collapse.vue'
import CollapseItem from '@/components/element/CollapseItem.vue'
import LangSwitch from '@/components/app/LangSwitch.vue'

export default defineComponent({
  name: 'SidebarPage',
  components: {
    LangSwitch,
    Collapse,
    CollapseItem
  },
  setup(_, { root }) {
    const activeNames = ref(['/' + root.$route.params.slug])

    const { onResult, refetch } = useGetMenuPagesQuery({
      locales: useGetLocales(root.$i18n)
    })

    // TODO
    const menu: any = useAsync<MenuPageFragment[]>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            resolve(result?.data?.menu ?? [])
          })
        )
    )

    if (process.client) {
      root.$on(AppEvents.LocaleChanged, () => {
        refetch({
          locales: useGetLocales(root.$i18n)
        })
      })

      onResult(result => {
        menu.value = result?.data?.menu ?? []
      })
    }

    return {
      activeNames,
      menu
    }
  }
})
</script>
